#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <linux/types.h>

/* we don't want linux/time.h */
#define _LINUX_TIME_H 1
#include "videodev2.h"
#include <stdio.h>


MODULE = Video::ivtv		PACKAGE = Video::ivtv		

void
getResolution(fd, width, height)
		int fd
		int &width
		int &height
	INIT:
		struct v4l2_format vfmt;

	CODE:
    /* printf("Before ioctl...\n"); */
		if (ioctl(fd, VIDIOC_G_FMT, &vfmt) < 0)
		{
			/* return an invalid case to signal an error occured */
			width = height = -1;
		}
		else
		{
      /* printf("width = %d, height = %d\n", vfmt.fmt.pix.width, vfmt.fmt.pix.height); */
			width = vfmt.fmt.pix.width;
			height = vfmt.fmt.pix.height;
		}
	OUTPUT:
		width 
		height


int
setResolution(fd, width, height)
		int fd
		int width
		int height
	INIT:
		struct v4l2_format vfmt;

    /* make sure we have valid input values. */
    if (width < 0 || width > 720)
    {
			XSRETURN_UNDEF;
		}
		if (height < 0 || height > 576)
		{
			XSRETURN_UNDEF;
		}
	CODE:
    /* printf("Before ioctl...\n"); */
		vfmt.type = 1;  /* make sure the buf type is set for Video Capture! */
    vfmt.fmt.pix.width = width;
		vfmt.fmt.pix.height = height;
		if (ioctl(fd, VIDIOC_S_FMT, &vfmt) < 0)
		{
			/* return an invalid case to signal an error occured */
			RETVAL = 0;
		}
    else
    {
			RETVAL = 1;
		}
	OUTPUT:
		RETVAL

